package javax.naming.ldap;

import com.sun.jndi.ldap.BerEncoder;
import java.io.IOException;

public final class PagedResultsControl extends BasicControl
{
    public static final String OID = "1.2.840.113556.1.4.319";
    private static final byte[] EMPTY_COOKIE;
    private static final long serialVersionUID = 6684806685736844298L;
    
    public PagedResultsControl(int n, boolean b) throws IOException {
        super("1.2.840.113556.1.4.319", b, (byte[])null);
        this.value = this.setEncodedValue(n, PagedResultsControl.EMPTY_COOKIE);
    }
    
    public PagedResultsControl(int n, byte[] empty_COOKIE, boolean b) throws IOException {
        super("1.2.840.113556.1.4.319", b, (byte[])null);
        if (empty_COOKIE == null) {
            empty_COOKIE = PagedResultsControl.EMPTY_COOKIE;
        }
        this.value = this.setEncodedValue(n, empty_COOKIE);
    }
    
    private byte[] setEncodedValue(int i, byte[] tb) throws IOException {
        BerEncoder berEncoder = new BerEncoder(10 + tb.length);
        berEncoder.beginSeq(48);
        berEncoder.encodeInt(i);
        berEncoder.encodeOctetString(tb, 4);
        berEncoder.endSeq();
        return berEncoder.getTrimmedBuf();
    }
    
    static {
        EMPTY_COOKIE = new byte[0];
    }
}
